library Fractcvr;

{ Important note about DLL memory management: ShareMem must be the
  first unit in your library's USES clause AND your project's (select
  Project-View Source) USES clause if your DLL exports any procedures or
  functions that pass strings as parameters or function results. This
  applies to all strings passed to and from your DLL--even those that
  are nested in records and classes. ShareMem is the interface unit to
  the BORLNDMM.DLL shared memory manager, which must be deployed along
  with your DLL. To avoid using BORLNDMM.DLL, pass string information
  using PChar or ShortString parameters. }

{%File '..\..\..\Projects\Project1.dpr'}

uses
  Windows,
  Graphics,
  Math {,jpeg,},
  ExtCtrls,SysUtils,
  nsftplgdecl in '..\dynadll\nsftplgdecl.pas';

type TMandelbrotParams=record
	ReMin,ReMax,ImMin,ImMax:double;
        Max_iter,Cols:integer;
end;
{$R *.res}

procedure GetPluginInfo(var plgInfo:TPlugInInfo);stdcall;
begin
  plgInfo.PluginClass:=NSFT_ASCIIDRAWER;
  plgInfo.Editable:=false;
  plgInfo.PluginName:='NSFT ASCII Drawer::Fractals';
  plgINfo.PluginInfo:='Generates random fractal covers. Default string must be "-2,1.25,-1.25,1.25,256,"';
end;

procedure ParseString(s:string;var FractPar:TMandelbrotParams);
//format:remin,remax,immin,immax,maxiter

var i,field,c:integer;
    tmp:double;
    ss:string;
begin
ss:='';
field:=0;
for i:=1 to Length(s) do
begin
   if s[i]<>',' then ss:=ss+s[i]
   else
    begin
     val(ss,tmp,c);
     with FractPar do
	     case field of
        	0:remin:=tmp;
                1:remax:=tmp;
                2:immin:=tmp;
                3:immax:=tmp;
                4:Max_Iter:=trunc(tmp);
                5:cols:=trunc(tmp);
	     end;{case}
//     end;{with}
	ss:='';
     inc(field);
    end;{else}
end;
end;

function GenerateAsciiBasedBitMap(w,h:integer;AsciiString:string;Path:string):integer;stdcall;
var i,j:integer;
//    r,g,b:byte;
    fp:TMandelbrotParams;
    InMemory:TBitMap;
    dx,dy,A,oldA,B:double;
    color:integer;
const MAX_BYTE=$FF;
begin
//format:remin,remax,immin,immax,maxiter
//AsciiString:='-2,1.25,-1.25,1.25,256,';
ParseString(AsciiString,fp);
if w*h<=2 then
 begin
    Result:=NSFT_ERROR_INVALIDDIM;
    exit;
 end;
if FileExists(path) then
begin
	Result:=ERROR_FILE_EXISTS;
     exit;
end;
 randomize;
 fp.Max_iter:=random(fp.Max_iter);
{ eps:=0.1*random;
 len:=eps*random;
 fp.ReMin:=fp.ReMin+(fp.ReMax-fp.ReMin)*random;
 fp.remax:=fp.ReMin+len;
 len:=len*h/w;
 fp.ImMin:=fp.ImMin+(fp.ImMax-fp.ImMin)*random;
 fp.Immax:=fp.ImMin+len;
assignfile(f,'out.txt');
rewrite(f);
writeln(f,fp.remin,',',fp.remax,',',fp.immin,',',fp.immax);
closefile(f);}
 { fp.ReMin:=-2;
 fp.ReMax:=1.25;
 fp.ImMin:=-1.25;
 fp.ImMax:=1.25;
 fp.Max_iter:=127;}
randomize;
InMemory:=TBitMap.Create;
InMemory.Height:=h;
InMemory.Width:=w;
dx:=(fp.ReMax-fp.ReMin)/w;
dy:=(fp.ImMax-fp.ReMin)/h;
for i:=0 to w do
   for j:=0 to h do
     begin
     	color:=0;
          A:=0;B:=0;
          while (sqr(A)+sqr(B)<4) and (color<fp.Max_iter) do
          begin
          	oldA:=A;
               A:=sqr(A)-Sqr(b)+fp.ReMin+i*dx;
               B:=2*oldA*B+fp.ImMin+j*dy;
               inc(color);
          end;
     	InMemory.Canvas.Pixels[i,j]:=$FFFFFF-trunc($FFFFFF*(color/fp.Max_iter));
   end;{for j}
   inMemory.SaveToFile(Path);
   InMemory.free;
   Result:=ERROR_SUCCESS;
end;

exports
  GenerateAsciiBasedBitMap,
  GetPluginInfo;
begin
end.
